<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class workVAR
{
    /*перенаправление пользователя*/
    
    function move_back()
    {
        header('location: '.$_SERVER['HTTP_REFERER']);
        exit;
    }
    
    /*перенаправление пользователя по определенному адресу*/
    
    function move_to($link)
    {
        header('location: '.$link);
        exit;       
    }
    
    /*вывести страницу 404*/

    function not_found()
    {
        header('HTTP/1.0 404 Not Fount');
        include("404.html");
        exit;
    }
    
    function move301($link)
    {
        header("HTTP/1.1 301 Moved Permanently");
        header('location: '.$link);
        exit;
    }
    
    /*МЕТОДЫ ПО РАБОТЕ С ПЕРЕМЕННЫМИ (ОБРАБОТКА)*/
    
    /*экранирование текстовых переменных*/
    
    function clear_string($string)
    {
        $string = htmlspecialchars($string);
        $string = addslashes($string);
        
        return $string;
    }
    
    /*экранирование html переменных*/
    
    function clear_html($html)
    {
        $html = addslashes($html);
        
        return $html;
    }
    
    /*принудительное формирование числовой переменной*/
    
    function clear_int($int)
    {
        return $int = intval($int);
    }

    /*принудительное формирование флоат переменной*/
    
    function clear_float($float)
    {
        return $float = floatval($float);
    }
    
    /*проверка корректности чпу*/
    
    function check_chpu_link($chpu)
    {
        if (preg_match("/^[-\.a-z0-9\/]+(?:\/|(?:\.html))$/s", $chpu))
            return TRUE;
        else
            return FALSE;
    }

    /*проверка корректности пути к изображению*/
    
    function check_img_link($img)
    {
        if (preg_match("/^[-\.a-z0-9\/\:_]+\.(?:jpg|gif|png|bmp)$/s", $img))
            return TRUE;
        else
            return FALSE;
    }

    /* проверка логина */

    function check_login($login)
    {
        if (preg_match("/^[-_A-Za-z0-9]{4,12}$/", $login))
            return TRUE;
        else
            return FALSE;        
    }
    
    /* проверка мыла */
    
    function check_email($email)
    {
        if (preg_match("/^[-_\.A-Za-z0-9]{1,25}@[-_\.A-Za-z0-9]{1,25}\.[a-z]{2,5}$/", $email))
            return TRUE;
        else
            return FALSE;        
    }

    /* проверка сайта */
    
    function check_site($site)
    {
        if (preg_match("/^(?:http|https):\/\/[-_a-zа-я0-9.]+\.[a-zа-я]{2,6}\/{0,1}$/s", $site))
            return TRUE;
        else
            return FALSE;        
    }

    /* проверка пароля */
    
    function check_password($password)
    {
        if (preg_match("/^[A-Za-z0-9]{4,16}$/", $password))
            return TRUE;
        else
            return FALSE;         
    }

    /* проверка даты без времени */
    
    function check_date($cdate)
    {
        if (preg_match("/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/", $cdate))
            return TRUE;
        else
            return FALSE;         
    }

    /* проверка даты с временем */
    
    function check_datetime($cdate)
    {
        if (preg_match("/^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}$/", $cdate))
            return TRUE;
        else
            return FALSE;         
    }

    /*Транслит. Переделываем русские или английские слова в транслит (алиас)*/
    
    function get_translit($string)
    {   
        $russimvol = array(
            "а","А","б","Б","в","В","г","Г","д","Д","е","Е","ё","Ё","ж","Ж","з","З",
            "и","И","й","Й","к","К","л","Л","м","М","н","Н","о","О","п","П","р","Р",
            "с","С","т","Т","у","У","ф","Ф","х","Х","ц","Ц","ч","Ч","ш","Ш","щ","Щ",
            "ы","Ы","э","Э","ю","Ю","я","Я","a","A","b","B","c","C","d","D","e","E",
            "f","F","g","G","h","H","i","I","j","J","k","K","l","L","m","M","n","N",
            "o","O","p","P","q","Q","r","R","s","S","t","T","u","U","v","V","w","W",
            "x","X","y","Y","z","Z","1","2","3","4","5","6","7","8","9","0","-"," ",".");
        
        $anglsimvol = array(
            "a","a","b","b","v","v","g","g","d","d","e","e","jo","jo","zh","zh",
            "z","z","i","i","j","j","k","k","l","l","m","m","n","n","o","o","p","p",
            "r","r","s","s","t","t","u","u","f","f","h","h","c","c","ch","ch",
            "sh","sh","shh","shh","y","y","je","je","ju","ju","ja","ja","a","a",
            "b","b","c","c","d","d","e","e","f","f","g","g","h","h","i","i",
            "j","j","k","k","l","l","m","m","n","n","o","o","p","p","q","q",
            "r","r","s","s","t","t","u","u","v","v","w","w","x","x","y","y",
            "z","z","1","2","3","4","5","6","7","8","9","0","-","-",".");
                            
        $string = iconv('UTF-8','windows-1251',$string);
        
        for($i=0;isset($string[$i]);$i++)
        {
            for($sim=0;$sim<=127;$sim++)
            {
                if(iconv('windows-1251','UTF-8',$string[$i]) == $russimvol[$sim])
                {
                    $result .= $anglsimvol[$sim];
                    break;
                }
            }
        }
        
        return $result;
    }
    
    function get_now_date()
    {
        return date('Y-m-d H:i:s');
    }

    /*обработуи даты: ДД месяца YYYY г. ЧЧ:ММ*/
    
    function change_date($datetime)
    {
        $date_array = explode(" ", $datetime);
        $date_array = explode("-", $date_array[0]);
        
        $time_array = explode(" ", $datetime);
        $time_array = explode(":", $time_array[1]);
        
        $array_month = array
        (
            '01'    => 'Января',
            '02'    => 'Февраля', 
            '03'    => 'Марта', 
            '04'    => 'Апреля', 
            '05'    => 'Мая', 
            '06'    => 'Июня', 
            '07'    => 'Июля', 
            '08'    => 'Августа', 
            '09'    => 'Сентября', 
            '10'    => 'Октября', 
            '11'    => 'Ноября', 
            '12'    => 'Декабря' 
        );
        
        return $date_array[2]." ".$array_month[$date_array[1]]." ".$date_array[0]." г. ".$time_array[0].":".$time_array[1];
    }
    
    function get_array_value($value)
    {
        $separator = '{'.time().'}';
        $value = str_replace(LINE, $separator, $value);    
        
        $value = explode($separator, $value);
       
        foreach ($value as $v)
        {
            $v = explode(":", $v);
            $result[trim($v[0])] = (count(explode(',', $v[1])) > 1) ? explode(',', $v[1]) : trim($v[1]);
        }
        
        return $result;
    }

    // вывести копию объекта
    function get_object($name)
    {
        if (isset($GLOBALS[$name]))
            return $GLOBALS[$name];
            
        return FALSE;
    }
    
    // метод генерирующий путь до записи по каталогу
    function get_parents_dir($catalog_id, $root, &$path, $base = '')
    {
        if ($catalog_id == 0)
            $this->search_up_tree($catalog_id, $root);
        
        if (!empty($GLOBALS['rssite']['cachecatalog'][$root]))
        {
            $catalog = $GLOBALS['rssite']['cachecatalog'][$root];
            
            if (empty($base))
                $base = (isset($catalog[0]['base'])) ? $catalog[0]['base'] : '';
            
            foreach ($catalog as $value)
            {
                if ($value['id'] == $catalog_id)
                {               
                    $path[] = $value['alias'];
                    
                    if ($value['parent'] != 0 )
                        $this->get_parents_dir($value['parent'], $root, $path, $base);
                    else
                        if (!empty($base))
                            $path[] = $base;
                }
            }
        }

        if (empty($path))
            if ((!empty($base)))
                $path[] = $base;
    }
    
    function search_up_tree(&$catalog_id, &$root)
    {
        if (empty($GLOBALS['rssite']['cachecatalog']))
            return FALSE;
            
        foreach ($GLOBALS['rssite']['cachecatalog'] as $tree => $sections)
            foreach ($sections as $section)
                if ($section['map_id'] == $root)
                {
                    $root         = $tree;
                    $catalog_id   = $section['id'];
                    
                    break;
                    break;
                }
                
        return TRUE;
    }
    
    // позволяет поменять имя узла в хлебных крошках
    function get_caption($name = '', $code = FALSE)
    {
        if (!isset($GLOBALS['massiv_tree']['breadcrumbs.intro']))
            return FALSE;
        
        $chpu = '/'.$_GET['chpu_links'];
        
        if (!empty($name)) {
            foreach ($GLOBALS['massiv_tree']['breadcrumbs.intro'] as $key => $node)
                if ($code === FALSE) {
                    if ($chpu == $node['path'])
                        $GLOBALS['massiv_tree']['breadcrumbs.intro'][$key]['name'] = $name;
                }
                else
                    if ($code == $node['code'])
                        $GLOBALS['massiv_tree']['breadcrumbs.intro'][$key]['name'] = $name;
        }
        else {
            foreach ($GLOBALS['massiv_tree']['breadcrumbs.intro'] as $key => $node)
                if ($chpu == $node['path'])
                    return $GLOBALS['massiv_tree']['breadcrumbs.intro'][$key]['name'];
        }
    }

    function nl2brPre($input) 
    { 
        $input = preg_replace('%\n%i','<br/>',$input); 
    
        preg_match_all('%<pre\s*[^>]*>.+?</pre>%i',$input,$a); 
    
        for($i=0; $i < sizeof($a); $i++)
            $input = str_replace($a[$i], str_replace("\n","<br />",$a[$i]), $input); 
    
        return $input;  
    }

}
?>