<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class paramGroup extends core
{
    /*инициализация объектов для работы данного класса*/
    public function paramGroup($value)
    {
        $this->core();
        
        $this->parent = (isset($GLOBALS['groupid'])) ? $this->tools->clear_int($GLOBALS['groupid']) : NULL;
        
        // проверки на существование групп
        $group_id     = (isset($GLOBALS['groupid']))    ? $this->tools->clear_int($GLOBALS['groupid'])    : '';
        $subgroup_id  = (isset($GLOBALS['subgroupid'])) ? $this->tools->clear_int($GLOBALS['subgroupid']) : '';
        
        // проверяем группу
        if ($group_id !== '')
            if (!$this->checkGroup($group_id))
                $this->tools->not_found();
        
        // проверяем вложенную группу        
        if ($subgroup_id !== '')
            if (!$this->checkGroup($subgroup_id))
                $this->tools->not_found();
    }
        
    /* CASE : BROWSE */
    
    public function getGroup()
    {
        $this->getCaptionName();
        
        $sql = ""
            ."SELECT"
                ." gr.group_id       AS group_id,"
                ." gr.group_name     AS group_name,"
                ." gr.group_parent   AS group_parent,"
                ." gr.group_position AS group_position"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ." gr.group_parent ".( ($this->parent == NULL) ? "IS NULL" : "= '".$this->parent."'" )
            ." ORDER BY group_position"
        ;

        if (!$groups = $this->db->accept_select($sql))
            return array();

        return $groups;
    }
    
    /* CASE : ADD */
    
    public function addGroup(&$fields)
    {
        if (empty($fields['group_name'])) {
            $fields['error'] = 'name.empty';
            return FALSE;            
        }
        
        // подсчитываем позицию
        $sql = "SELECT COUNT(*) FROM rs_param_group WHERE group_parent ".( ($this->parent == NULL) ? "IS NULL" : "= '".$this->parent."'" );
        $group_position = $this->db->accept_count_select($sql) + 1;
        
        $what['group_name']     = $fields['group_name'];
        $what['group_position'] = $group_position;
        
        if ($this->parent != NULL)
            $what['group_parent'] = $this->parent;

        $this->db->accept_insert($what, 'rs_param_group');

        $this->tools->move_to('/admin/parameter/'.( ($this->parent != NULL) ? $this->parent.'/' : '' ));
    }
    
    /* CASE : EDIT */
    
    public function showForm()
    {
        $group_id = (isset($GLOBALS['subgroupid'])) ? $this->tools->clear_int($GLOBALS['subgroupid']) : $this->tools->clear_int($GLOBALS['groupid']);
        
        if ($group_id == 0)
            return array('error' => 'id.empty');
            
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id,"
                ." gr.group_name   AS group_name"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ." gr.group_id = '".$group_id."'"
        ;
        
        if (!$group = $this->db->accept_select($sql))
            return array('error' => 'group.noexist');
            
        return $group[0];
    }
    
    public function editGroup($fields)
    {
        // проверка имени
        if (empty($fields['group_name'])) {
            $fields['error'] = 'name.empty';
            return $fields;
        }
        
        // проверка корректности id группы
        $group_id = (isset($GLOBALS['subgroupid'])) ? $this->tools->clear_int($GLOBALS['subgroupid']) : $this->tools->clear_int($GLOBALS['groupid']);
       
        if ($group_id == 0) {
            $fields['error'] = 'id.empty';
            return $fields;
        }
        
        // проверка наличия группы
        $sql = ""
            ."SELECT"
                ." gr.group_id     AS group_id,"
                ." gr.group_name   AS group_name"
            ." FROM"
                ." rs_param_group gr"
            ." WHERE"
                ." gr.group_id = '".$group_id."'"
        ;
        
        if (!$group = $this->db->accept_select($sql)) {
            $fields['error'] = 'group.noexist';
            return $fields;
        }
        
        // обновляем запись
        $what = array(
            'group_name'       => $fields['group_name']
        );

        $this->db->accept_update($what, 'rs_param_group', "group_id='".$group_id."'");

        $this->tools->move_to('/admin/parameter/'.( (isset($GLOBALS['subgroupid'])) ? $this->parent.'/' : '' ));
    }

    /* CASE : DELETE */
    
    public function deleteGroup($group_id)
    {
        // удаляем группу
        $this->db->accept_delete("DELETE FROM rs_param_group WHERE group_id='".$group_id."'");
        
        // если не существует id вложенной группы, стало быть удаляется корень
        if (!isset($GLOBALS['groupid'])) {
            
            // ищем вложнные группы
            $sql = ""
                ."SELECT"
                    ." gr.group_id AS group_id"
                ." FROM"
                    ." rs_param_group gr"
                ." WHERE"
                    ." gr.group_parent = '".$group_id."'"
            ;
            
            if ($groups = $this->db->accept_select($sql))
                foreach ($groups as $group) {
                    // удаляем вложенную группу
                    $sql = "DELETE FROM rs_param_group WHERE group_id='".$group['group_id']."'";
                    
                    $this->db->accept_delete($sql);
                    // удаляем параметры и значения
                    $this->deleteParam($group['group_id']);
                }
        }
        else
            // если удаляется не корень, то удаялем только параметры
            $this->deleteParam($group_id);
        
        if (!$this->update_position())
            die('ERROR UPDATE POSITION');
        
        die('OK');
    }
    
    private function update_position()
    {
        // выводим группы по паренту
        $sql = ""
            ."SELECT"
                ." group_id"
            ." FROM"
                ." rs_param_group"
            ." WHERE"
                ." group_parent ".( ($this->parent === NULL) ? "IS NULL" : "= '".$this->parent."'" )
        ;
        
        // обновляем позицию
        if (!$position = $this->db->accept_select($sql))
            return FALSE;


        $new_position = 1;
        foreach ($position as $value)
        {
            $what   = array('group_position' => $new_position);
            $where  = 'group_id=\''.$value['group_id'].'\'';
            
            $this->db->accept_update($what, 'rs_param_group', $where);
            
            $new_position++;
        }
        
        return TRUE;
    }
    
    private function deleteParam($group_id)
    {
        // вытаскиваем параметры
        $sql = ""
            ."SELECT"
                ." param.param_id AS param_id"
            ." FROM"
                ." rs_param param"
            ." WHERE"
                ." param.group_id = '".$group_id."'"
        ;
        
        if (!$params = $this->db->accept_select($sql))
            return FALSE;
        
        // удаляем значение параметров
        foreach ($params as $param)
            $this->db->accept_delete("DELETE FROM rs_param_value WHERE param_id='".$param['param_id']."'");
        
        // удаляем параметры
        $this->db->accept_delete("DELETE FROM rs_param WHERE group_id='".$group_id."'");
        
        return TRUE;
    }

    /* CASE : POSITION */
    
    function change_position($group_id, $step)
    {
        $sql = ""
            ."SELECT"
                ." group_position"
            ." FROM"
                ." rs_param_group"
            ." WHERE"
                ."     group_id        = '".$group_id."'"
                ." AND group_parent    ".( ($this->parent == NULL) ? "IS NULL" : "= '".$this->parent."'" )
        ;
        
        if (!$position = $this->db->accept_select($sql))
            return FALSE;
        
        $old_position = $position[0]['group_position'];
            
        if ($step == 'down')
            $new_position = $position[0]['group_position'] + 1;
            
        if ($step == 'up')
            $new_position = $position[0]['group_position'] - 1;
            
        $sql = ""
            ."SELECT"
                ." group_id"
            ." FROM"
                ." rs_param_group"
            ." WHERE"
                ."     group_position  = '".$new_position."'"
                ." AND group_parent    ".( ($this->parent == NULL) ? "IS NULL" : "= '".$this->parent."'" )
        ;
        
        if (!$row_id = $this->db->accept_select($sql))
            return FALSE;
        
        $this->db->accept_update(array('group_position' => $new_position), 'rs_param_group', 'group_id=\''.$group_id.'\'');
        $this->db->accept_update(array('group_position' => $old_position), 'rs_param_group', 'group_id=\''.$row_id[0]['group_id'].'\'');
        
        die();
    }

    /* РАЗНОЕ */
    
    private function getCaptionName()
    {
        if (isset($GLOBALS['groupid'])) {
            
            $group_id = $this->tools->clear_int($GLOBALS['groupid']);
            
            $sql = "SELECT group_name FROM rs_param_group WHERE group_id = '".$group_id."'";
            
            if ($group_name = $this->db->accept_select($sql))
                $this->tools->get_caption($group_name[0]['group_name'], 'groupid');
        }
    }

    private function checkGroup($group_id)
    {
        $sql = ""
            ."SELECT"
                ." group_id"
            ." FROM"
                ." rs_param_group"
            ." WHERE"
                ."     group_id = '".$group_id."'"
        ;
        
        if (!$group = $this->db->accept_select($sql))
            return FALSE;
            
        return TRUE;
    }
}
?>