<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class sitemap extends core
{
    /*инициализация объектов для работы данного класса*/
    function sitemap($value)
    {
        $this->core();
    }
    
    /* CASE : BROWSE */
    
    function get_info_sm()
    {
        $result = array();
        
        if (!file_exists("./sitemap.xml"))
            return $result;

        
        $result['name']  = 'sitemap.xml';
        $result['count'] = $this->get_count();
        $result['size']  = $this->get_size();
        $result['time']  = $this->get_time();
        
        return $result;
    }
    
    // определяем время генерации
    function get_time()
    {
        return $this->tools->change_date(date('Y-m-d H:i:s', filemtime("./sitemap.xml")));
    }
    
    // определяем кол-во ссылок
    function get_count()
    {
        $sm = file("./sitemap.xml");
        $sm = implode("", $sm);
        
        preg_match_all("/(<url>.*?<\/url>)/s", $sm, $count);
        
        return count($count[0]);
    }
    
    // определяем размер карты
    function get_size()
    {
        $size = filesize("./sitemap.xml");

        $size_txt = array(' байт',' кбайт',' мбайт');

        for($i=0;$i<3;$i++)
        {
            if ($size >= 1024)
            {
                $size = $size/1024;
                $size = round($size, 2);
            }
            else
            {
                $size = $size.$size_txt[$i];
                break;
            }
        }
        
        return $size;
    }
    
    /* CASE : UPDATE */
    
    function update_sitemap()
    {
        $sql = ""
            ."SELECT"
                ." c.catalog_id as catalog_id,"
                ." c.content_id as content_id,"
                ." c.content_publication as content_publication,"
                ." m.map_alias as alias,"
                ." s.sitemap_change as sitemap_change,"
                ." s.sitemap_priority as sitemap_priority,"
                ." s.sitemap_change as sitemap_change,"
                ." m.map_parent as map_parent"
            ." FROM"
                ." rs_content c,"
                ." rs_map m,"
                ." rs_sitemap s"
            ." WHERE 1=1"
                ." AND c.map_id = m.map_id"
                ." AND c.content_id = s.sitemap_content"
                ." AND s.sitemap_active = '1'";


        if (!$urls = $this->db->accept_select($sql))
            $this->tools->move_to('/admin/sitemap/');

        foreach ($urls as $key => $value)
        {
            if (!preg_match("/^.*?\.html$/", $urls[$key]['alias']))
                $urls[$key]['alias']     = $urls[$key]['alias'].'/';

            if (!$this->get_catalog_tree($value['catalog_id']))
                $this->root = $value['map_parent'];
            
            $path = array();
            $this->tools->get_parents_dir($value['catalog_id'], $this->root, $path);
            
            $urls[$key]['link']          = $GLOBALS['rssite']['cfg']['server_root']
                                           .( (!empty($path)) ? implode('/', array_reverse($path)).'/'.$urls[$key]['alias'] : $urls[$key]['alias'] );
        }

        $xml  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
        $xml .= "\t<url>\n\t\t<loc>".$GLOBALS['rssite']['cfg']['server_root']."</loc>\n\t\t<lastmod>".date("Y-m-d")."</lastmod>\n\t\t<changefreq>daily</changefreq>\n\t\t<priority>1.0</priority>\n\t</url>\n";
        
        foreach ($urls as $url)
            $xml .= "\t<url>\n\t\t<loc>".$url['link']."</loc>\n\t\t<lastmod>".current(explode(' ', $url['content_publication']))."</lastmod>\n\t\t<changefreq>".$url['sitemap_change']."</changefreq>\n\t\t<priority>".$url['sitemap_priority']."</priority>\n\t</url>\n";
        
        $xml .= "</urlset>";

        $smFILE = fopen("./sitemap.xml", "w+");
        fwrite($smFILE, $xml);
        fclose($smFILE);
        
        $this->tools->move_to('/admin/sitemap/');
    }

    // определяем узел каталога
    function get_catalog_tree($catalog_id)
    {
        if (isset($this->root))
            unset($this->root);

        if (empty($GLOBALS['rssite']['cachecatalog']))
            return FALSE;

        foreach ($GLOBALS['rssite']['cachecatalog'] as $tree => $station)
        {
            foreach ($station as $key => $value)
                if ($value['id'] == $catalog_id)
                {
                    $this->root = $tree;
                    break;
                    break;
                }
        }
        
        if (!isset($this->root))
            return FALSE;

        return TRUE;
    }
    
    /* CASE : CLEAR */
    
    function sitemap_clear()
    {
        $smFILE = fopen("./sitemap.xml", "w+");
        fwrite($smFILE, '');
        fclose($smFILE);
        
        $this->tools->move_to('/admin/sitemap/');
    }
}
?>