<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class nesting extends core
{
    /*инициализация объектов для работы данного класса*/
    function nesting($value)
    {
        $this->core();
        
        $this->type   = $value['type'];
        $this->ncode  = (isset($_COOKIE['wnesting_code'])) ? $this->tools->clear_string($_COOKIE['wnesting_code']) : '';
    }
    
    /* CASE : BROWSE */
    function show_list ($widget_id)
    {
        $result = array();
        
        $result['files']   = $this->show_files($widget_id);
        
        return $result;
    }
    
    function show_files($widget_id)
    {
        if ($widget_id == 0)
            if (empty($this->ncode))
                return array();
                
        $sql  = "SELECT * FROM rs_widget_files WHERE";
        $sql .= ($widget_id == 0) ? " file_code='".$this->ncode."'" : " widget_id='".$widget_id."'";
        $sql .= " ORDER BY file_id DESC";
        
        if (!$files = $this->db->accept_select($sql))
            return array();
            
        return $files;
    }

    /* CASE : ADDFILE */
    
    function add_file (&$fields)
    {
        if ($fields['widget_id'] == 0)
            if (empty($this->ncode)) {
                $fields['error'] = 'content_id.empty';
                return FALSE;
            }
        
        if (empty($fields['nesting_file'])) {
            $fields['error'] = 'file.empty';
            return FALSE;
        }
        
        $file 			= $fields['nesting_file'];
        
        $file['type'] 	= mime_content_type($file['tmp_name']);
        
        $formats_array = array(
            'application/x-rar-compressed',
            'application/zip',
            'image/jpeg',
            'image/gif',
            'image/png',
            'image/bmp'
        );

        if (!in_array($file['type'], $formats_array)) {
            $fields['error'] = 'format.wrong';
            return FALSE;
        }
            
        $this->get_expansion($file['type']);
        
        $name = preg_replace('/(.*?)\.[a-z]{3,4}$/', '$1', $this->tools->get_translit($file['name']));
        
        if (mb_strlen($name) >= 32) {
            $fields['error'] = 'name.long';
            return FALSE;
        }
            
        if ($file['size'] > 6*1024*1024) {
            $fields['error'] = 'file.size';
            return FALSE;
        }
        
        $name = $this->check_name(trim($name), 'files');

        copy($file['tmp_name'], "content/files/".$name.$this->expansion);
        
        $what = array(
          'file_name'  => $fields['nesting_name'],
          'file_path'  => 'content/files/'.$name.$this->expansion,
          'file_type'  => ($this->expansion == '.rar' OR $this->expansion == '.zip') ? 0 : 1,
          'file_code'  => ($fields['widget_id'] == 0) ? $this->ncode : '',
          'widget_id' => $fields['widget_id']
        );
        
        $this->db->accept_insert($what, 'rs_widget_files');
    }
    
    function check_name($name, $folder, $sel = '')
    {
        if (file_exists("content/".$folder."/".$name.$sel.$this->expansion))
        {
            if ($sel == '')
                $sel = 0;
            
            $sel++;
            
            $result = $this->check_name($name, $folder, $sel);
        }
        else
            $result = $name.$sel;
            
        return $result;
    }
    
    function get_expansion($type)
    {
        switch($type)
        {
            case 'application/x-rar-compressed':
                $this->expansion = '.rar';
                break;
            case 'application/zip':
                $this->expansion = '.zip';
                break;
            case 'image/jpeg':
                $this->expansion = '.jpg';
                break;
            case 'image/gif':
                $this->expansion = '.gif';
                break;
            case 'image/png':
                $this->expansion = '.png';
                break;
            case 'image/bmp':
                $this->expansion = '.bmp';
                break;
        }        
    }

    /* CASE : EDITFILE */
    
    function show_edit_file($file_id)
    {
        $sql = "SELECT * FROM rs_widget_files WHERE file_id='".$file_id."'";
        
        if (!$result = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        return $result[0];
    }
    
    function edit_file($fields)
    {
        $sql = "SELECT widget_id FROM rs_widget_files WHERE file_id='".$fields['file_id']."'";
        
        if (!$widget_id = $this->db->accept_select($sql))
            die();
        
        $this->db->accept_update(array('file_name' => $fields['nesting_name']), 'rs_widget_files', "file_id='".$fields['file_id']."'");
        
        die();
    }
    
    /* CASE : DELETEFILE */
    
    function delete_file($file_id)
    {
        $sql = "SELECT file_path, widget_id FROM rs_widget_files WHERE file_id='".$file_id."'";
        
        if ($file = $this->db->accept_select($sql))
        {
            
            $file = $file[0]['file_path'];
            
            if (file_exists($file))
                unlink($file);
            
            $this->db->accept_delete("DELETE FROM rs_widget_files WHERE file_id='".$file_id."'");
        }
    }
}
?>