<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class comment extends core
{
    function comment($value)
    {
        $this->core();

        $this->content_id = $value['value'];
        $this->user_id    = (int)$GLOBALS['rssite']['user']['user_id'];
    }
    
    /* вывод список комментариев */
    function get_comment()
    {
        $sql = "SELECT * FROM rs_comment WHERE content_id='".$this->content_id."' ORDER BY comment_id";
        
        if (!$comments = $this->db->accept_select($sql))
            return array();
        
        foreach ($comments as $key => $value)
        {
            $comments[$key]['comment_publication'] = $this->tools->change_date($value['comment_publication']);
            
            if ($rs_bbcode = $this->tools->get_object('rs_bbcode'))
                $comments[$key]['comment_text']    = $rs_bbcode
                                                       ->setText($comments[$key]['comment_text'])
                                                       ->getHtml()
                                                   ;
                                                   
            $comments[$key]['comment_text']        = $this->tools->nl2brPre($comments[$key]['comment_text']);
        }
        
        $comments = $this->get_tree($comments);
        
        return $comments;
    }
    
    function get_tree($comments, $comment_parent = 0)
    {
        $result = array();
        
        foreach ($comments as $comment)
        {
            if ($comment['comment_parent'] == $comment_parent)
            {
                $comment['sub_comments'] = $this->get_tree($comments, $comment['comment_id']);
                $result[] = $comment;
            }
        }
        
        return $result;
    }
    
    /* вывод формы комментирования */
    function get_form($fields)
    {
        return $fields;
    }

    function get_hidden_comment()
    {
        if (isset($_COOKIE['comment']))
            $comment = unserialize($_COOKIE['comment']);
        else
            return array();
            
        return $comment;
    }
    
    /* добавление комментария */
    function add_comment($fields)
    {
        // принудительно заменяем некоторые данные пользователя, если тот аторизован
        $this->init_user($fields);
        
        // проверка записи
        $sql = "SELECT content_id, content_num_comm FROM rs_content WHERE content_id='".$fields['content_id']."'";        
        if (!$content = $this->db->accept_select($sql))
        {
            $fields['error'][0] = 'Нет записи';
            return $fields;
        }
        
        // проверка родителя комментария
        if ($fields['comment_parent'] != 0)
        {
            $sql = "SELECT comment_id, comment_email FROM rs_comment WHERE comment_id='".$fields['comment_parent']."'";
            
            if (!$comment = $this->db->accept_select($sql))
            {
                $fields['error'][1] = 'Нет родителя';
                return $fields;
            }
        }
        
        // проверка имени
        if (empty($fields['comment_author']))
        {
            $fields['error'][2] = 'Поле не должно быть пустым';
            return $fields;
        }
        
        // проверка сайта
        if (!empty($fields['comment_site']))
        {
            if (!$this->tools->check_site($fields['comment_site']))
            {
                $fields['error'][3] = 'Некорректный адрес сайта';
                return $fields;
            }
        }
        
        // проверка мыла
        if (empty($fields['comment_email']))
        {
            $fields['error'][4] = 'Поле не должно быть пустым';
            return $fields;
        }        

        if (!$this->tools->check_email($fields['comment_email']))
        {
            $fields['error'][5] = 'Некорректный электронный ящик';
            return $fields;
        }

        // проверка текста
        if (empty($fields['comment_text']))
        {
            $fields['error'][6] = 'Поле не должно быть пустым';
            return $fields;
        }

        // проверяем капчу
        if ($this->user_id <= 0)
        {
            $sole         = $GLOBALS['rssite']['cfg']['sole'];
            $session_name = 'content_'.$fields['content_id'];
            session_start();
            
            if (empty($fields['comment_code']))
            {
                $fields['error'][8] = 'Вы не подтвердили, что Вы человек';
                return $fields; 
            }                
            
            if (!isset($_SESSION[$session_name]))
            {
                $fields['error'][9] = 'Системная ошибка';
                return $fields;   
            }
            
            if ($_SESSION[$session_name] != md5($sole.$fields['comment_code']))
            {
                $fields['error'][10] = 'Вы выбрали не ту картинку';
                return $fields;                 
            }
        }
        
        // получаем статус пользователя
        $status = $this->get_status($fields);
        
        // добавляем комментарий
        $what = array(
            'comment_author'        => $fields['comment_author'],
            'comment_site'          => $fields['comment_site'],
            'comment_email'         => $fields['comment_email'],
            'comment_text'          => str_replace("\r\n", "\n", $fields['comment_text']),
            'comment_publication'   => $this->tools->get_now_date(),
            'comment_parent'        => $fields['comment_parent'],
            'content_id'            => $fields['content_id'],
            'comment_status'        => $status
        );
        
        if (!$fields['comment_id'] = $this->db->accept_insert($what, 'rs_comment', 'comment_id'))
        {
            $fields['error'][7] = 'Системная ошибка';
            return $fields;
        }
        
        // записываем куку с сообщением, что бы новый пользователь мог его видеть
        if ($status == 0)
            $this->set_cookie($fields['comment_id']);
        
        // если статус больше нуля, значит обновляем счетчик комментариев у контента
        if ($status != 0)
        {
            if ($fields['comment_parent'] != 0)
            {
                // переопределяем некоторые данные массива. главное оставить мыло родителя!
                $comment                      = $comment[0];
                $comment['comment_id']        = $fields['comment_id'];
                $comment['comment_author']    = $fields['comment_author'];
                $comment['comment_text']      = $fields['comment_text'];

                $this->send_for_user($comment);
            }
            
            $what = array(
                'content_num_comm'    => $content[0]['content_num_comm'] + 1
            );
            
            $this->db->accept_update($what, 'rs_content', "content_id='".$fields['content_id']."'");
        }
        
        $this->send_for_admin($fields);
        
        $this->tools->move_to($_SERVER['HTTP_REFERER'].'#comment_'.$fields['comment_id']);
            
        return FALSE;
    }
    
    // отправка почты для юзера, если на его комментарий пришел ответ
    function send_for_user($comment)
    {
        $sql = "SELECT user_id FROM rs_user WHERE user_email='".$comment['comment_email']."'";
        
        if (!$user = $this->db->accept_select($sql))
            return FALSE;
            
        $user = $user[0];
        
        if ($rs_bbcode = $this->tools->get_object('rs_bbcode'))
            $comment['comment_text'] = $rs_bbcode
                                         ->setText($comment['comment_text'])
                                         ->getText()
                                     ;
        $param = array(
            'user_id'    => $user['user_id'],
            'parser'    => array(
                'alias'   => 'usercomments',
                'msg'     => array(
                    'SITE'       => $_SERVER['HTTP_HOST'],
                    'NAME'       => $comment['comment_author'],
                    'MESSAGE'    => nl2br($comment['comment_text']),
                    'LINK'       => 'http://'.$_SERVER['HTTP_HOST'].'/'.$_GET['chpu_links'].'#comment_'.$comment['comment_id'],
                    'CMS'        => CMS.' v'.VERSION
                )
            )
        );
        
        $this->sendmail->get_param($param);
    }
    
    // отправка почты для администрации
    function send_for_admin($fields)
    {
        if ($rs_bbcode = $this->tools->get_object('rs_bbcode'))
            $fields['comment_text'] = $rs_bbcode
                                          ->setText($fields['comment_text'])
                                          ->getText()
                                      ;
        $param = array(
            'access'    => 'newcomments',
            'parser'    => array(
                'alias'   => 'admincomments',
                'msg'     => array(
                    'SITE'       => $_SERVER['HTTP_HOST'],
                    'NAME'       => $fields['comment_author'],
                    'MESSAGE'    => nl2br($fields['comment_text']),
                    'CMS'        => CMS.' v'.VERSION
                )
            )
        ); 
        
        $this->sendmail->get_param($param);       
    }
    
    // если пользователь авторизован то принудительно перезаписываем некоторые присланные данные
    function init_user(&$fields)
    {
        if ($this->user_id <= 0)
            return FALSE;
        
        $fields['comment_author'] = $GLOBALS['rssite']['user']['user_name'];
        $fields['comment_email']  = $GLOBALS['rssite']['user']['user_email'];
        $fields['comment_site']   = $GLOBALS['rssite']['user']['user_site'];
            
        return TRUE;
    }
    
    // метод позволяет определеить статус пользователя
    function get_status($fields)
    {
        if ($this->user_id > 0)
            return $GLOBALS['rssite']['user']['user_status'];
        else
            $status = 0;
        
        $sql = "SELECT * FROM rs_user WHERE user_email='".$fields['comment_email']."'";
        
        if (!$user = $this->db->accept_select($sql))
        {
            $what = array(
                'field_site'    => $fields['comment_site']
            );
            
            if ($group_id = $this->db->accept_insert($what, 'rs_profile_additional_fields', 'group_id'))
            {
                $what = array(
                    'user_name'        => $fields['comment_author'],
                    'user_login'       => '',
                    'user_password'    => md5(md5($GLOBALS['rssite']['cfg']['sole']).md5('123456')),
                    'user_email'       => $fields['comment_email'],
                    'user_more'        => $group_id,
                    'user_status'      => 0,
                    'user_access'      => 0,
                    'user_hash'        => ''
                );
                
                if ($user_id = $this->db->accept_insert($what, 'rs_user', 'user_id'))
                {
                    $what = array(
                        'user_login'   => 'user_'.$user_id
                    );
                    
                    $this->db->accept_update($what, 'rs_user', "user_id='".$user_id."'");
                }
            }
        }
        else
            $status = $user[0]['user_status'];
        
        return $status;
    }
    
    // создание куки для пользователей которые комментирую первый раз. кука позволит видеть свой комментарий
    function set_cookie($comment_id)
    {
        if (isset($_COOKIE['comment']))
            $comment = unserialize($_COOKIE['comment']);
        else
            $comment = array();
            
        $comment[] = $comment_id;
        
        setcookie('comment', serialize($comment), time()+(24*60*60), '/');
    }
}
?>